parameter x0,y0,x1,y1, color, inc, thick, light

	private inc, a,s,c,s_inc,c_inc,x,y

	*- normalize Increament value
	inc = iif(empty(inc),0.1,abs(inc))
	
	a=atn2(x1-x0, y1-y0)
	s=sin(a)
	c=cos(a)
	
	s_inc = (s*inc)
	c_inc = (c*inc)
	
	store x0 to x
	store y0 to y
	
	do while between(x,min(x0,x1),max(x0,x1)) ;
		 and between(y,min(y0,y1),max(y0,y1))
		  
		do plot with x,y, color, thick, light
		x=x+s_inc
		y=y+c_inc
		
	enddo
	
	return
	
*- plot point
procedure plot
parameter x,y, color, thick, light

	private fr,fg,fb,br,bg,bb
	store 0 to fr,fg,fb,br,bg,bb
	color = iif(empty(color), 'RGB', color)
	thick = iif(empty(thick),0.1, thick)
	do c2RGB with color, fr,fg,fb,br,bg,bb, light
	if between(x,0,wrow()-0.2) and between(y,0,wcol()-0.1)
		@ x,y to x+thick,y PEN 1 pattern 1 color RGB(fr,fg,fb,br,bg,bb)
	endif
	return
	
procedure c2rgb
parameter c, fr,fg,fb,br,bg,bb, light

	private l, cb
	c = c+'/ '
	store 0 to fr,fg,fb,br,bg,bb
	cb  = alltrim(upper(substr(c,at('/',c)+1)))
	c   = alltrim(upper(left(c,at('/',c)-1)))
	l   = iif(light,255/128,1)
	do case
	case c='RGB'
		fr = 128*l
		fg = 128*l
		fb = 128*l
	case c='RB'
		fr = 128*l
		fb = 128*l
	case c='BG'
		fr = 128*l
		fg = 128*l
	case c='GR'
		fg = 128*l
		fb = 128*l
	case c='R'
		fr = 128*l
	case c='G'
		fg = 128*l
	case c='B'
		fb = 128*l
	endcase	
	do case
	case cb='RB'
		br = 128*l
		bb = 128*l
	case cb='BG'
		br = 128*l
		bg = 128*l
	case cb='GR'
		bg = 128*l
		bb = 128*l
	case cb='R'
		br = 128*l
	case cb='G'
		bg = 128*l
	case cb='B'
		bb = 128*l
	endcase	
	return
	
* Dark Red		128,0,0		R	R
* Dark Yellow	128,128,0	GR	GR
* Dark Green	0,128,0		G	G
* Dark Cyan		0,128,128	BG	BG
* Dark Blue		0,0,128		B	B
* Dark Magenta	128,0,128	RB	RB
	